//
//  CHFullscreenWindow.h
//  Chocolat
//
//  Created by Pieter Omvlee on 3/14/09.
//  Copyright 2009 Bohemian Coding. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CHArrayExtensions.h"


@interface CHFullscreenWindow : NSWindow
{
  NSToolbar *fullScreenToolbar;
}

+ (CHFullscreenWindow *)fullScreenWindowWithContentView:(NSView *)contentView onScreen:(NSScreen *)aScreen;
+ (CHFullscreenWindow *)fullScreenWindowWithContentView:(NSView *)contentView animatingFromRect:(NSRect)baseRect toScreen:(NSScreen *)aScreen;

- (BOOL)isInFullScreenMode;
- (BOOL)canBecomeKeyWindow;

- (NSView *)fullScreenView;

- (NSView *)newToolbarViewForToolbar:(NSToolbar *)aToolbar forFrame:(NSRect)aRect;

@end